function Bezier() {
    this.points = new Array();
    this.dimention = null;
    this.lut = new Array();

    this.addPoint = function(x,y,z) {
        if (this.dimention == null) {
            this.dimention = 0;
        } else {
            this.dimention++;
        }
        this.points[this.dimention] = new Object();
        this.points[this.dimention].x = x;
        this.points[this.dimention].y = y;
        this.points[this.dimention].z = z;
    }

    this.getPoint = function(theta) {
        var point = {x: 0, y: 0, z: 0};

        for (var i = 0; i <= this.dimention; i++) {
            var binom = this.binomial(this.dimention, i);
            var polynom = Math.pow((1-theta), (this.dimention-i))*Math.pow(theta, i);

            // console.log("theta: " + theta + ", Binom: " + binom + ", P1: " + Math.pow((1-theta), (this.dimention-i)) + ", P2: " + Math.pow(theta, i));
            // console.log("n-i: " + (this.dimention-i) + ", i: " + i);

            point.x += this.points[i].x * binom * polynom;
            point.y += this.points[i].y * binom * polynom;
            point.z += this.points[i].z * binom * polynom;
        }

        // console.log("Theta: " + theta + ", x: " + point.x + ", y: " + point.y + ", z: " + point.z);

        return point;
    }

    this.getLine = function(divs) {
        var len = 1/divs;
        var i = 0;
        var point;
        var vertices = new Array();

        while (i * len <= 1) {
            point = this.getPoint(i*len);
            vertices[i*3] = point.x;
            vertices[i*3 + 1] = point.y;
            vertices[i*3 + 2] = point.z;
            i++;
        }

        return vertices;
    }

    this.binomial = function(n, k) {
        while (n >= this.lut.length) {
            var nextRow = new Array();
            nextRow[0] = 1;
            for (var i = 1; i <= this.lut.length-1; i++) {
                nextRow[i] = this.lut[this.lut.length-1][i-1] + this.lut[this.lut.length-1][i];
            }
            nextRow[this.lut.length] = 1;
            this.lut[this.lut.length] = nextRow;
        }

        return this.lut[n][k];
    }
}