function SF(S0, P0, psi0, ds, Nl, kappa, depth) {
    var s = [];
    var pd = [];
    var psid = [];
    var td = [];
    var nd = [];
    var points = [];

    var stripWidth = 0.1;

    s[0] = S0;
    pd[0] = P0;
    points[0] = pd[0][0];
    points[1] = pd[0][1];

    psid[0] = psi0;
    td[0] = [math.cos(psid[0]), math.sin(psid[0])];

    nd[0] = [-math.sin(psid[0]), math.cos(psid[0])];

    for (var i = 0; i < Nl-1; i++) {
        s[i+1]    = s[i] + ds;
        pd[i+1]   = [pd[i][0] + td[i][0] * ds, pd[i][1] + td[i][1] * ds];
        psid[i+1] = psid[i] + kappa * ds;
        td[i+1]   = [td[i][0] + kappa * nd[i][0] * ds,td[i][1] + kappa * nd[i][1] * ds];
        td[i+1]   = [td[i+1][0]/norm(td[i+1]),td[i+1][1]/norm(td[i+1])];
        nd[i+1]   = [nd[i][0] - kappa * td[i][0] * ds, nd[i][1] - kappa * td[i][1] * ds];
        nd[i+1]   = [nd[i+1][0]/norm(nd[i+1]),nd[i+1][1]/norm(nd[i+1])];

        points[(i+1)*6]     = pd[i+1][1] - nd[i+1][1] * stripWidth/2;
        points[(i+1)*6 + 1] = pd[i+1][0] - nd[i+1][0] * stripWidth/2;
        points[(i+1)*6 + 2] = -depth;

        points[(i+1)*6 + 3]     = pd[i+1][1] + nd[i+1][1] * stripWidth/2;
        points[(i+1)*6 + 4] = pd[i+1][0] + nd[i+1][0] * stripWidth/2;
        points[(i+1)*6 + 5] = -depth;
    }

    return points;
}

function norm(input)
{
    return Math.sqrt(input[0]*input[0]+input[1]*input[1]);
}