var depth = 0;
var heading = 0;
var battery = 100;
var xPos = 0;
var yPos = 0;

var yaw = 0;
var surge = 0;
var heave = 0;
var sway = 0;
var headingCmd = 0;
var seq = 0;

var autoDepth = 0;
var autoHeading = 0;
var desX = 0;
var desY = 0;
var desX_in = 0;
var desY_in = 0;

var controlMode = "Motion";

setInterval(updatePathfollowing, 500);

// Connecting to ROS
// -----------------

var ros = new ROSLIB.Ros({
    //url: 'ws://10.0.0.69:9091'
    //url: 'ws://192.168.0.100:9090'
    //url: 'ws://10.22.101.63:9090'
    url: 'ws://127.0.0.1:9090'
});


ros.on('connection', function () {
    console.log('Connected to websocket server.');
});

ros.on('error', function (error) {
    console.log('Error connecting to websocket server: ', error);
});

ros.on('close', function () {
    console.log('Connection to websocket server closed.');
});

// Publishing a Topic
// ------------------

//Control inputs
var joyPub = new ROSLIB.Topic({
    ros: ros,
    name: '/joy',
    messageType: 'sensor_msgs/Joy'
});

var joycommand = new ROSLIB.Message({
    header: {
        seq: 1,
        stamp: {
            secs: 0,
            nsecs: 0
        },
        frame_id: '',
    },
    axes: data = [0, 0, 0, 0, 0, 0, 0, 0],
    buttons: data = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
});

joyPub.publish(joycommand);


// Subscribing topubContolMode
var listener = new ROSLIB.Topic({
    ros: ros,
    name: '/statusCtrlAlg',
    messageType: 'udrone/statusControlAlgorithms'
});

//sendcommand
function sendcommand(value, dir) {
    if (path_mode) {
        if (dir == "yaw") {
            var _kappa = -2 * value;
            setKappa(_kappa);
            joy_x = value;
        } else if (dir == "surge") {
            /*if (value < 0) {
                value = 0;
            }

            var length = 15*value + 80*Math.abs(kappa);

            var _Nl = Math.round(Math.min(length, 15));
            setNl(_Nl);*/
        } else if (dir == "heave") {
            var speed_command = ({
                desired_velocity: value
            });

            pubPathVelocity.publish(speed_command);
        }
    } else {
        switch (dir) {
            case "sway":
                sway = 0.5 * value;
                break;
            case "heave":
                heave = 0.75 * value;
                break;
            case "surge":
                surge = 0.5 * value;
                break;
            case "yaw":
                yaw = 1.5 * value;
                break;
            default:
                return;
        }
        joycommand = ({
            header: {
                seq: seq,
                stamp: {
                    secs: 0,
                    nsecs: 0
                },
                frame_id: '',
            },
            axes: data = [yaw, surge, 0, sway, heave, 0, 0, 0, 0, 0],
            buttons: data = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
        });
        seq = seq + 1;

        joyPub.publish(joycommand);
    }
}

//changeInputMode
function changeControlMode(input) {
    path_mode = false;

    switch (input) {
        case "Motion":
            joycommand = ({
                header: {
                    seq: seq,
                    stamp: {
                        secs: 0,
                        nsecs: 0
                    },
                    frame_id: '',
                },
                axes: data = [0, 0, 0, 0, 0, 0, 0, 0],
                buttons: data = [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
            });
            break;
        case "AutoD":
            joycommand = ({
                header: {
                    seq: seq,
                    stamp: {
                        secs: 0,
                        nsecs: 0
                    },
                    frame_id: '',
                },
                axes: data = [0, 0, 0, 0, 0, 0, 0, 0],
                buttons: data = [0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0]
            });
            break;
        case "AutoH":
            joycommand = ({
                header: {
                    seq: seq,
                    stamp: {
                        secs: 0,
                        nsecs: 0
                    },
                    frame_id: '',
                },
                axes: data = [0, 0, 0, 0, 0, 0, 0, 0],
                buttons: data = [0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0]
            });
            break;
        case "Direct":
            joycommand = ({
                header: {
                    seq: seq,
                    stamp: {
                        secs: 0,
                        nsecs: 0
                    },
                    frame_id: '',
                },
                axes: data = [0, 0, 0, 0, 0, 0, 0, 0],
                buttons: data = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
            });
            break;
        case "Oculus":
            joycommand = ({
                header: {
                    seq: seq,
                    stamp: {
                        secs: 0,
                        nsecs: 0
                    },
                    frame_id: '',
                },
                axes: data = [0, 0, 0, 0, 0, 0, 0, 0],
                buttons: data = [0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0]
            });
            break;
        case "OculusDP":
            joycommand = ({
                header: {
                    seq: seq,
                    stamp: {
                        secs: 0,
                        nsecs: 0
                    },
                    frame_id: '',
                },
                axes: data = [0, 0, 0, 0, 0, 0, 0, 0],
                buttons: data = [0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0]
            });
            break;
        case "DP":
            initializeDP();
            joycommand = ({
                header: {
                    seq: seq,
                    stamp: {
                        secs: 0,
                        nsecs: 0
                    },
                    frame_id: '',
                },
                axes: data = [0, 0, 0, 0, 0, 0, 0, 0],
                buttons: data = [0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0]
            });
            break;
        case 'Pathfollowing':
            initializePathfollowing();
            joycommand = ({
                header: {
                    seq: seq,
                    stamp: {
                        secs: 0,
                        nsecs: 0
                    },
                    frame_id: '',
                },
                axes: data = [0, 0, 0, 0, 0, 0, 0, 0],
                buttons: data = [0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0]
            });
            break;
        default:
            return;
    }
    seq = seq + 1;
    joyPub.publish(joycommand);
}

function sendDirectThust() {
    joycommand = ({
        header: {
            seq: seq,
            stamp: {
                secs: 0,
                nsecs: 0
            },
            frame_id: '',
        },
        axes: data = [Number(document.getElementById("direct_thr_control1").value),
            Number(document.getElementById("direct_thr_control2").value),
            Number(document.getElementById("direct_thr_control3").value),
            Number(document.getElementById("direct_thr_control4").value),
            Number(document.getElementById("direct_thr_control5").value),
            Number(document.getElementById("direct_thr_control6").value),
            0, 0],
        buttons: data = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    });
    seq = seq + 1;
    joyPub.publish(joycommand);
    console.log(joycommand.axes);
}

var pubDesiredParameters = new ROSLIB.Topic({
    ros: ros,
    name: '/desired_pos_from_HMI',
    messageType: 'std_msgs/Float64MultiArray'
});

var pubPathParameters = new ROSLIB.Topic({
    ros: ros,
    name: '/path_following/update_path',
    messageType: 'path_following/update_path'
});

var pubPathVelocity = new ROSLIB.Topic({
    ros: ros,
    name: '/path_following/desired_velocity',
    messageType: 'path_following/desired_velocity'
});

//set Auto Depth
function setAutoDepth(pix) {
    autoDepth = depth + pix / 80;
    if (autoDepth < 0) {
        autoDepth = 0;
    }
    desPosCmd = ({
        data: data = [desX, desY, autoDepth, autoHeading]
    });
    pubDesiredParameters.publish(desPosCmd);
}

function setDPinput(inX, inY) {
    desX = inX + delta_xPos;
    desY = inY + delta_yPos;
    desPosCmd = ({
        data: data = [desX, desY, autoDepth, autoHeading]
    });
    pubDesiredParameters.publish(desPosCmd);
}

//set Auto Heading
function setAutoHeading(pix) {
    autoHeading = heading + pix / 11.1 * 2;
    autoHeading = autoHeading / 180 * Math.PI;
    if (autoHeading > Math.PI / 6) {
        autoHeading = Math.PI / 6;
    }
    else if (autoHeading < -Math.PI / 6) {
        autoHeading = -Math.PI / 6;
    }
    desPosCmd = ({
        data: data = [desX, desY, autoDepth, autoHeading]
    });
    pubDesiredParameters.publish(desPosCmd);
}

function initializeDP() {
    desX = xPos;
    desY = yPos;
    autoDepth = depth;
    autoHeading = heading;
    desPosCmd = ({
        data: data = [xPos, yPos, depth, heading]
    });
    pubDesiredParameters.publish(desPosCmd);
}

function initializePathfollowing() {
    path_mode = true;

    Nl = 0;
    kappa = 0;
    init_x_pos = pathCurrentDesiredX = xPos;
    init_y_pos = pathCurrentDesiredY = yPos;
    autoDepth = -0.5;
    autoHeading = pathCurrentDesiredHeading = psiPos;

    desPathCmd = ({
        Nl: 0,
        kappa: 0.0,
        initial_position_x: xPos,
        initial_position_y: yPos,
        initial_heading: psiPos,
        depth: -0.25,
        heading_mode: 1
    });
    pubPathParameters.publish(desPathCmd);
}

function updatePathfollowing() {
    //setNl(Nl_set)
    //setKappa(kappa_set);
    if (path_mode) {
        init_x_pos = pathCurrentDesiredX;
        init_y_pos = pathCurrentDesiredY;
        init_psi = pathCurrentDesiredHeading;

        Nl = 15;

        if (Math.abs(kappa_last - kappa) > 0.05) {
            var desPathCmd = ({
                Nl: Nl,
                kappa: kappa,
                initial_position_x: pathCurrentDesiredX,
                initial_position_y: pathCurrentDesiredY,
                initial_heading: pathCurrentDesiredHeading, //((init_psi * Math.PI)/180),
                depth: -0.5,
                heading_mode: 1
            });
            pubPathParameters.publish(desPathCmd);

            kappa_last = kappa;
        }
    } else {
        Nl = 0;
    }
}

//pub Camera Paramers
var pubCameraParameters = new ROSLIB.Topic({
    ros: ros,
    name: '/cameraParameters',
    messageType: 'std_msgs/Float32MultiArray'
});

var cameraParametersCommand = new ROSLIB.Message({
    data: data = [0, 0, 0, 0, 0, 0, 0, 0]
});

function sendCameraParameters() {
    var fisheye = 1;
    if (document.getElementById("camera_fisheye").checked) {
        fisheye = 0;
    }
    cameraParametersCommand = ({
        data: data = [Number(document.getElementById("camera_contrast").value),
            Number(document.getElementById("camera_brightness").value),
            Number(document.getElementById("camera_rotation").value),
            Number(document.getElementById("camera_zoom").value),
            Number(document.getElementById("camera_offsetx").value),
            Number(document.getElementById("camera_offsety").value),
            Number(document.getElementById("camera_red").value),
            Number(document.getElementById("camera_green").value),
            Number(document.getElementById("camera_blue").value),
            fisheye]
    });
    //console.log(cameraParametersCommand.data);
    pubCameraParameters.publish(cameraParametersCommand);
}

//depth
var imuListener = new ROSLIB.Topic({
    ros: ros,
    name: '/imu',
    messageType: 'udrone/imu'
});

imuListener.subscribe(function (message) {
    //console.log('Received message on ' + depthListener.name + ': ' + message.depth);
    //displayHeading(message.heading);
    if (controlMode == "AutoD" || controlMode == "AutoH") {
        displayDepth(message.depth);
    }
});

var posListener = new ROSLIB.Topic({
    ros: ros,
    name: '/xhat',
    messageType: 'udrone/xhat'
});

posListener.subscribe(function (message) {
    //console.log('Received message on ' + depthListener.name + ': ' + message.depth);
    if (controlMode == "DP" || controlMode == "OculusDP" || path_mode) {
        displayDepth(message.z+1.5);
    }
    displayHeading(message.psi / Math.PI * 180);
    xPos = message.x;
    yPos = message.y;
    zPos = -message.z;
    psiPos = message.psi;
    displayXY();
});

//Desired Depth
var desiredDepthListener = new ROSLIB.Topic({
    ros: ros,
    name: '/autoDepthInfo',
    messageType: 'udrone/autoDepthInfo'
});

desiredDepthListener.subscribe(function (message) {
    if (controlMode == "AutoD" || controlMode == "AutoH" || path_mode) {
        displayDesiredDepth(message.desiredDepth);
    }
});

var desiredHeadingListener = new ROSLIB.Topic({
    ros: ros,
    name: '/autoHeadingInfo',
    messageType: 'udrone/autoDepthInfo'
});

desiredHeadingListener.subscribe(function (message) {
    if (controlMode == "AutoD" || controlMode == "AutoH") {
        displayDesiredHeading(message.desierdDepth * 180 / Math.PI);
    }
});

var desiredPosListener = new ROSLIB.Topic({
    ros: ros,
    name: '/desiredPos',
    messageType: 'std_msgs/Float64MultiArray'
});

desiredPosListener.subscribe(function (message) {
    if (controlMode == "DP" || controlMode == "OculusDP" || path_mode) {
        displayDesiredHeading(message.data[3] * 180 / Math.PI);
        displayDesiredDepth(message.data[2]);
        desX_in = message.data[0];
        desY_in = message.data[1];
        displayXY();
    }
    if (path_mode) {
        pathCurrentDesiredHeading = message.data[3];
        pathCurrentDesiredX = message.data[0];
        pathCurrentDesiredY = message.data[1];
    }
});

var subPathDesiredPos = new ROSLIB.Topic({
    ros: ros,
    name: '/desired_position',
    messageType: 'udrone/desiredPosition'
});

subPathDesiredPos.subscribe(function(msg) {
    if (path_mode) {
        pathCurrentDesiredX       = msg.x_desired;
        pathCurrentDesiredY       = msg.y_desired;
        pathCurrentDesiredHeading = msg.psi_desired;

        displayDesiredHeading(msg.psi_desired * 180 / Math.PI);
        displayDesiredDepth(msg.z_desired);
        desX_in = msg.x_desired;
        desY_in = msg.y_desired;
        displayXY();
    }
});

//status
var statusListener = new ROSLIB.Topic({
    ros: ros,
    name: '/currentStatus',
    messageType: 'std_msgs/Float32MultiArray'
});

statusListener.subscribe(function (message) {
    if (message.data[3] == 1) {
        controlMode = "Motion"
        $(".direct_thr_control").hide();
        $(".aDepth_indicator").hide();
        $(".leftJoyStick_c").show();
        $(".aHeading_indicator").hide();
        $(".rightJoyStick_c").show();
        $(".DP-control").hide();
        $(".bottom-table").css("margin", "0 auto");
        document.getElementById("depth_scale_div").style.height = "200px";
        document.getElementById("controlMode_Motion").style.backgroundColor = "rgba(0, 255, 0, 0.5)";
        document.getElementById("controlMode_Direct").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_AutoD").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_AutoH").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_Oculus").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        //document.getElementById("controlMode_DP").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        //document.getElementById("controlMode_OculusDP").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_Path").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
    }
    /*else if (message.data[4] == 1) {
        $(".direct_thr_control").show();
        $(".aDepth_indicator").hide();
        $(".leftJoyStick_c").hide();
        $(".aHeading_indicator").hide();
        $(".rightJoyStick_c").show();
        $(".DP-control").hide();
        $(".bottom-table").css("margin", "0 auto");
        document.getElementById("depth_scale_div").style.height = "200px";
        controlMode = "Direct";
        document.getElementById("controlMode_Motion").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_Direct").style.backgroundColor = "rgba(0, 255, 0, 0.5)";
        document.getElementById("controlMode_AutoD").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_AutoH").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_Oculus").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        //document.getElementById("controlMode_DP").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        //document.getElementById("controlMode_OculusDP").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_Path").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
    }*/
    else if (message.data[2] == 1) {
        $(".direct_thr_control").hide();
        $(".aDepth_indicator").show();
        $(".leftJoyStick_c").hide();
        $(".aHeading_indicator").show();
        $(".rightJoyStick_c").show();
        $(".DP-control").hide();
        $(".bottom-table").css("margin", "0 auto");
        document.getElementById("depth_scale_div").style.height = "300px";
        controlMode = "AutoD";
        document.getElementById("controlMode_Motion").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_Direct").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_AutoD").style.backgroundColor = "rgba(0, 255, 0, 0.5)";
        document.getElementById("controlMode_AutoH").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_Oculus").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        //document.getElementById("controlMode_DP").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        //document.getElementById("controlMode_OculusDP").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_Path").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
    }
    else if (message.data[1] == 1) {
        $(".direct_thr_control").hide();
        $(".aDepth_indicator").show();
        $(".leftJoyStick_c").hide();
        $(".aHeading_indicator").show();
        $(".rightJoyStick_c").show();
        $(".DP-control").hide();
        $(".bottom-table").css("margin", "0 auto");
        document.getElementById("depth_scale_div").style.height = "300px";
        controlMode = "AutoH";
        document.getElementById("controlMode_Motion").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_Direct").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_AutoD").style.backgroundColor = "rgba(0, 255, 0, 0.5)";
        document.getElementById("controlMode_AutoH").style.backgroundColor = "rgba(0, 255, 0, 0.5)";
        document.getElementById("controlMode_Oculus").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        //document.getElementById("controlMode_DP").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        //document.getElementById("controlMode_OculusDP").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_Path").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
    }
    else if (message.data[0] == 1) {
        $(".direct_thr_control").hide();
        $(".aDepth_indicator").hide();
        $(".leftJoyStick_c").show();
        $(".aHeading_indicator").hide();
        $(".rightJoyStick_c").show();
        $(".DP-control").hide();
        $(".bottom-table").css("margin", "0 auto");
        controlMode = "Oculus";
        document.getElementById("depth_scale_div").style.height = "200px";
        document.getElementById("controlMode_Motion").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_Direct").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_AutoD").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_AutoH").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_Oculus").style.backgroundColor = "rgba(0, 255, 0, 0.5)";
        //document.getElementById("controlMode_DP").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        //document.getElementById("controlMode_OculusDP").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_Path").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
    }
    else if (message.data[5] == 1) {
        controlMode = "DP";
        $(".direct_thr_control").hide();
        $(".aDepth_indicator").show();
        $(".aHeading_indicator").show();
        $(".leftJoyStick_c").hide();
        $(".rightJoyStick_c").hide();
        $(".DP-control").show();
        $(".bottom-table").css("margin", "0 70");
        document.getElementById("depth_scale_div").style.height = "300px";
        document.getElementById("controlMode_Motion").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_Direct").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_AutoD").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_AutoH").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_Oculus").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        //document.getElementById("controlMode_DP").style.backgroundColor = "rgba(0, 255, 0, 0.5)";
        //document.getElementById("controlMode_OculusDP").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_Path").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
    }
    else if (message.data[6] == 1) {
        $(".direct_thr_control").hide();
        $(".aDepth_indicator").show();
        $(".aHeading_indicator").show();
        $(".leftJoyStick_c").hide();
        $(".rightJoyStick_c").hide();
        $(".DP-control").show();
        $(".bottom-table").css("margin", "0 70");
        controlMode = "OculusDP";
        document.getElementById("depth_scale_div").style.height = "300px";
        document.getElementById("controlMode_Motion").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_Direct").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_AutoD").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_AutoH").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_Oculus").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        //document.getElementById("controlMode_DP").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        //document.getElementById("controlMode_OculusDP").style.backgroundColor = "rgba(0, 255, 0, 0.5)";
        document.getElementById("controlMode_Path").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
    }
    else if (message.data[4] == 1) {
        $(".direct_thr_control").hide();
        $(".aDepth_indicator").show();
        $(".aHeading_indicator").show();
        $(".leftJoyStick_c").show();
        $(".rightJoyStick_c").show();
        $(".DP-control").hide();
        $(".bottom-table").css("margin", "0 auto");
        controlMode = "";
        path_mode = true;
        document.getElementById("depth_scale_div").style.height = "300px";
        document.getElementById("controlMode_Motion").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_Direct").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_AutoD").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_AutoH").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_Oculus").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        //document.getElementById("controlMode_DP").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        //document.getElementById("controlMode_OculusDP").style.backgroundColor = "rgba(255, 0, 0, 0.5)";
        document.getElementById("controlMode_Path").style.backgroundColor = "rgba(0, 255, 0, 0.5)";
    }
});
